
        .data
zona:   .hword 1234, 26, -453, 83, -7000, 0
        .hword -15000, 1, 777, 2020, 987, 10

        .text
/*
  Programa de prueba del enunciado
*/
main:   ldr r4, =zona
        mov r5, #20
loop:      
        ldr r6, [r4, r5]
        push {r6}
        cmp r5, #0
        beq next
        sub r5, #4
        b loop
next:   bl ordena
        ldr r4, =zona
        mov r5, #0
loopf:  pop {r6}
        str r6, [r4, r5]
        cmp r5, #20
        beq endf
        add r5, #4
        b loopf
endf:   wfi

/*
  hswap: subprograma de la primera parte.

  Recibe las direcciones de las dos medias palabras
  a intercambiar en r0 y r1.
  
*/

hswap:  ldrh r2, [r0] 
        ldrh r3, [r1]
        strh r3, [r0]
        strh r2, [r1]
        mov pc, lr

/*
 ordena: subprograma de la segunda parte.

 Dadas 12 medias palabras en la pila 
 devuelva esas mismas medias palabras en la pila ordenadas,
 utilizando el algoritmo de la burbuja.
*/
ordena: push {r4-r7,lr}    @ salvaguardamos los registros r4-r7
        mov r7, sp         
        add r7, #20        @ r7: puntero al principio de la lista
        mov r4, #1         @ r4: índice i = 1
       
for1:   cmp r4, #12        @ ¿i = 12?
        beq fin1
        mov r5, #0         @ r5: índice j = 0
        mov r6, #0         @ r6: desplazamiento en la tabla de lista[j]
       
for2:   cmp r5, #11        @ ¿j = 11?
        beq fin2

        ldsh r0,[r7,r6]    @ r0:lista[j] (extensión de signo)
        add r5, #1         @ j = j + 1 
        add r6, #2
        ldsh r1, [r7,r6]   @ r1=lista[j+1] (extensión de signo)

        cmp r0, r1
        ble for2           @ si lista[j] <= lista[j + 1], iteramos
       
        push {r0,r1}       @ lista[j] > lista[j + 1: intercambiar
        add r1, r7,r6      @ r1: dirección de lista[j+1]
        sub r0, r1,#2      @ r0: dirección de lista[j]
        bl hswap           @ llamada al subprograma del primer
        pop {r0,r1}        @ ejercicio
        b for2             @ y volvemos a iterar
       
fin2:   add r4, #1         @ i = i + 1
        b for1

fin1:   pop {r4-r7,pc}
       .end
