        .data
zona:   .byte   '2', '6', '7', '3', '4', '2', '8', '5', '2', '3', '3'
d_ult:  .byte   '2'
        .balign  4
i_zona: .word   zona     @ comienzo de la zona
f_zona: .word   d_ult    @ fin de la zona
cuenta: .space  10       @ tabla con el número de apariciones. 


   .text
main:
   ldr   r4,=cuenta    @ tabla de resultados
   mov   r5, #0        @ índice de dígitos
   ldr   r0,=i_zona
   ldr   r0,[r0]       @ puntero al principio de la zona
   ldr   r1,=f_zona
   ldr   r1,[r1]       @ puntero al final de la zona
   push  {r0, r1}      @ salvaguardamos los punteros
otro:
   mov   r2,#'0'
   add   r2,r5         @ dígito a contar
   bl    cuentad
   strb  r0,[r4,r5]    @ almacenamos el resultado
   cmp   r5,#9 
   beq   final
   add   r5,r5,#1      @ incrementamos el índice
   ldr   r0,[sp]       @ recuperamos los punteros al
   ldr   r1,[sp,#4]    @ principio y final de la zona
   b     otro

final:
   add   sp,sp,#8      @ balanceamos la pila
   wfi

/*
cuentad: subprograma para contar cuántos caracteres hay en una 
  zona de memoria. 
  Parámetros:
    - r0: dirección de comienzo de la zona de memoria.
    - r1: dirección de comienzo del último elemento en la zona de memoria.
    - r2: carácter a buscar.
  Resultado:
    - r0: número de ocurrencias del carácter pasado como parámetro. 
*/
cuentad:  
   push  {r4}        @ salvaguardamos r4
   mov   r4,#0       @ r4: contador de apariciones
buc:
   cmp   r0,r1       @ ¿final de la tabla?
   bgt   finsr

   ldrb  r3,[r0]     @ cargamos un carácter
   cmp   r3,r2       @ vemos si es el carácter buscado
   bne   noes

   add   r4,r4,#1    @ si es, incrementamos el contador
noes:   
   add   r0,r0,#1    @ incrementamos el puntero
   b     buc

finsr:
   mov   r0,r4       @ pasamos el contador al registro de resultado
   pop   {r4}        @ recuperamos r4
   mov   pc,lr       @ retornamos
   .end
