
     .data
num: .byte   5
     .balign 4
res: .space  4

   .text
main:
   ldr   r0, =num   @ tomamos el numero
   ldrb  r0, [r0]
   bl    factor     @ llamamos al subprograma
   ldr   r1, =res
   strb  r0, [r1]   @ guardamos el resultado

   wfi


/*
   factor:
   subprograma de cálculo del factorial de manera recursiva

   entrada: r0 = número para calcular su factorial
   salida:  r0 = factorial del numero

   p. ej, si llamamos con r0 = 5 el subprograma devuelve 
   r0 = 120 = 0x78

*/

factor:
   cmp   r0, #2         @ comprobamos si el cálculo es trivial
   bge   mayor1       

   mov   r0, #1         @ 0! = 1! = 1
   mov   pc, lr         @ hemos terminado
@
@ fact (n) = fact(n-1) * n
@
mayor1:
   push  {r1, lr}
   mov   r1, r0
   sub   r0, #1   
   bl    factor         @ llamamos con n - 1
   mul   r0, r1         @ multiplicamos el resultado por n
   pop   {r1, pc}       @ y volvemos
   .end
   
